"""empty message

Revision ID: dbe238baca46
Revises: 70752cee95cd
Create Date: 2021-08-08 12:17:24.867756

"""
from alembic import op
import sqlalchemy as sa
from sqlalchemy.dialects import postgresql

# revision identifiers, used by Alembic.
revision = "dbe238baca46"
down_revision = "70752cee95cd"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "feed",
        sa.Column("id", postgresql.UUID(as_uuid=True), nullable=False),
        sa.Column("project", postgresql.UUID(as_uuid=True), nullable=True),
        sa.Column("glucose", sa.Float(), nullable=True),
        sa.Column("glutamine", sa.Float(), nullable=True),
        sa.Column("lactate", sa.Float(), nullable=True),
        sa.Column("glutamate", sa.Float(), nullable=True),
        sa.Column("ammonia", sa.Float(), nullable=True),
        sa.ForeignKeyConstraint(
            ["project"],
            ["project.id"],
        ),
        sa.PrimaryKeyConstraint("id"),
    )
    op.create_table(
        "project_settings",
        sa.Column("project_id", postgresql.UUID(as_uuid=True), nullable=False),
        sa.Column("fed_batch_call_density", sa.Float(), nullable=True),
        sa.Column("fed_batch_viability", sa.Float(), nullable=True),
        sa.Column("perfusion_bleed", sa.Float(), nullable=True),
        sa.Column("perfusion_viability", sa.Float(), nullable=True),
        sa.Column(
            "objective_penalty",
            sa.Enum(
                "SQUARED_ERROR",
                "AUTO_CORRELATION",
                "AUTOCOV",
                name="objectivepenalty",
            ),
            nullable=False,
        ),
        sa.Column(
            "date_type",
            sa.Enum("DAYS", "HOURS", name="datetype"),
            nullable=False,
        ),
        sa.Column(
            "viable_cell_density_type",
            sa.Enum("E_SIX", "E_FIVE", "NORMAL", name="viablecelldensitytype"),
            nullable=False,
        ),
        sa.Column("bleed_controller_gain", sa.Float(), nullable=True),
        sa.Column("bleed_controller_rest_time", sa.Float(), nullable=True),
        sa.Column("max_oxygen_rate", sa.Float(), nullable=True),
        sa.Column("perfusion_rate_threshold", sa.Float(), nullable=True),
        sa.Column(
            "source_of_toxicity",
            sa.Enum("LYSED_CELLS", "BIOMATERIAL", name="datasource"),
            nullable=False,
        ),
        sa.Column(
            "source_of_inhibition",
            sa.Enum("LYSED_CELLS", "BIOMATERIAL", name="datasource"),
            nullable=False,
        ),
        sa.ForeignKeyConstraint(
            ["project_id"],
            ["project.id"],
        ),
        sa.PrimaryKeyConstraint("project_id"),
    )
    op.add_column(
        "fit_parameters",
        sa.Column("module", sa.String(length=50), nullable=True),
    )
    op.add_column(
        "fit_parameters",
        sa.Column("function", sa.String(length=50), nullable=True),
    )
    op.add_column(
        "fit_parameters",
        sa.Column(
            "threshold", postgresql.JSON(astext_type=sa.Text()), nullable=True
        ),
    )
    op.drop_column("fit_parameters", "trash_hold")
    op.drop_column("fit_procedures", "number_of_processes")
    op.alter_column(
        "fit_procedures",
        "batches_to_fit",
        type_=postgresql.ARRAY(sa.String()),
        existing_type=postgresql.ARRAY(sa.Integer()),
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "fit_procedures",
        sa.Column(
            "number_of_processes",
            postgresql.DOUBLE_PRECISION(precision=53),
            autoincrement=False,
            nullable=True,
        ),
    )
    op.add_column(
        "fit_parameters",
        sa.Column(
            "trash_hold",
            postgresql.JSON(astext_type=sa.Text()),
            autoincrement=False,
            nullable=True,
        ),
    )
    op.drop_column("fit_parameters", "threshold")
    op.drop_column("fit_parameters", "function")
    op.drop_column("fit_parameters", "module")
    op.drop_table("project_settings")
    op.drop_table("feed")
    op.alter_column(
        "fit_procedures",
        "batches_to_fit",
        type_=postgresql.ARRAY(sa.Integer()),
        existing_type=postgresql.ARRAY(sa.String()),
    )
    # ### end Alembic commands ###
